/* Rexx */
/*-------------------------------------------------------*/
/* Command file to update VATC server install with              */
/*   V3hotfix2 for WIN.                                                      */
/* Renames updated files to *.hf1 and copies new files         */
/*  from a V3hotfix.  Rebind step is included for whatever      */
/*  family is set in TC_FAMILY.  User can decline rebind        */
/*------------------------------------------------------*/

'@echo off'
do while queued() > 0
   pull junk
end /* do */
/* call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs */

env = 'Environment'  /* default is WIN */
lessmsg = ' >NUL 2>&1 '
here = directory()
back3 = 'bk2'  /* backup extension for changed files */

parse source platform . .
sysplat = platform
platform = translate(platform)  /* Upper case */
select
   when platform = 'OS/2' then
      do
         env = 'OS2ENVIRONMENT'
         opSys = 'os2'
      end
   when platform = 'WINDOWSNT' then
      do
         env = 'Environment'
         opSys = 'win'
      end
   when platform = 'WINDOWS95' then
      do
         env = 'Environment'
         opSys = 'win'
      end
   when platform = 'WIN' then
      do
         env = 'Environment'
         opSys = 'win'
      end
otherwise do
     say 'Cannot determine operating system'
     say sysplat ' was returned as platform'
     say ' hotapply.cmd must be modified. '
     EXIT
  end  
end  /* select */

TCdir = value( 'TC_HOME',, env )
TCfam = value( 'TC_FAMILY',,env )

TCdll = TCdir'\dll'

if stream(TCdll,'c','query datetime') = '' then do
  say 'Cannot find Team Connection directory, tried using ' TCdir
  say 'Stopping'
  EXIT
end /* do */


/* check for server structure */
TCchk = TCdir'\NLS\CFG\_tcbase.bnd'
TCcfg = TCdir'\NLS\CFG'
if stream(TCchk,'c','query exists') <> '' then do
/* do dlls first */
  here1 = here'\SERVER'
  call directory TCdll
  if opSys = 'win' then do
    call docopy 'FHMBUILD.DLL', here1
    call docopy 'FHMHTTPD.DLL', here1
    call docopy 'FHMKRNL.DLL', here1
    call docopy 'FHMCMNS.DLL', here1
    call docopy 'FHMMODEL.DLL', here1  
    call docopy 'FHMMYSTC.DLL', here1
   end
  else do  /* OS2 */
    call docopy 'FHBBUILD.DLL', here1
    call docopy 'FHCHTTPD.DLL', here1
    call docopy 'FHCKRNL.DLL', here1
    call docopy 'FHCCMNS.DLL', here1
    call docopy 'FHCMODEL.DLL', here1  
    call docopy 'FHCMYSTC.DLL', here1
   end
/* now bind files */
  call directory TCcfg
  call docopy 'adlink.bnd', here1
  call docopy 'admerge.bnd', here1
  call docopy 'adobject.bnd', here1
  call docopy 'advroot.bnd', here1
  call docopy 'fhccntxt.bnd', here1
  call docopy 'fhcfgfld.bnd', here1
  call docopy 'fhcversn.bnd', here1
  call docopy 'fixup.bnd', here1
  call docopy 'session.bnd', here1
  call docopy 'tccollc.bnd', here1
  call docopy 'tctrans.bnd', here1
  call docopy '_tcbase.bnd', here1
  call docopy '_tcbuild.bnd', here1
  call docopy '_tcmod.bnd', here1
  call docopy 'fhcaccss.bnd', here1
  call docopy 'fhclevel.bnd', here1
  call docopy 'fhcpath.bnd', here1
  call docopy 'fhcuser.bnd', here1



  say '*********ATTENTION************************'
  say ' You must re-bind the family data base now.'
  say ' Some errors are acceptable. '
  say ' Please refer to the hotfix readme file'
  say '******************************************'
  say ' '
  say ' '
  say 'TC_FAMILY is set to ' TCfam
  say 'Proceed to re-bind ' TCfam' Yes|No ?'
  parse upper pull reply
  reply = strip(reply)
  if reply = 'YES' | reply = 'Y' then do
     say ' Have you completed DB2 backup of 'TCfam ' Yes|No ?'
     parse upper pull reply
     reply = strip(reply)
     if reply = 'YES' | reply = 'Y' then do
        say ' Running FHCIRT '
        fhcirt TCcfg'\*.bnd '
     end /* do reply */
  end /* do YES or Y */
end /* do if TCChk exists */

TCchk1 = TCdir'\bin\teamcgui.exe'
TCbin = TCdir'\bin'
if stream(TCchk1,'c','query exists') <> '' then do
/* copy Client dlls */
  here1 = here'\CLIENT'
  call directory(TCdll)
    if opSys = 'win' then do
      call docopy 'fhmclint.dll', here1
      call docopy 'fhmcmnc.dll', here1 
      call docopy 'fhmrscli.dll', here1
     end
  /* need these for both */
  call docopy 'fhcclint.dll', here1
  call docopy 'fhccmnc.dll', here1
  call docopy 'fhcrscli.dll', here1
end /* if client */

call directory here
say 'Finished '
return

docopy: procedure expose back3 bkname
  file = arg(1)
  fromdir = arg(2)

  parse var file fname '.' ftype
  bkname = fname ||'.' || back3
  say 'Renaming ' file ' to ' bkname
  'rename' file bkname  /* rename so original backup is never overwritten */
  say 'Copying ' file
  copy fromdir'\'file
 return

